$ verify = 'F$VERIFY(0)'
$!.. TLBEDIT.COM			Edit/manipulate text library modules
$!.. Description and history at end of file
$ TELL := WRITE SYS$OUTPUT
$ VT := $FERMI$EXE:T
$ ee := EDIT/EDT				!Default to EDT editor
$ IF F$TYPE(EDT) .NES. "" THEN ee = EDT		!If EDT symbol defined...
$ IF F$TYPE(EDTX) .NES. "" THEN ee = EDTX	!If EDTX symbol defined...
$L1$:
$ IF p1 .EQS. "" THEN $ INQUIRE  p1  "Text library"
$ IF p1 .EQS. "" THEN $ GOTO L1$
$ read_only := FALSE		!Remove /READONLY qualifier if used
$ qual = F$ELEMENT( 1, "/", p1)
$ IF qual .EQS. "/" THEN $ GOTO SKIP_EXTRACTING
$ p1 = F$ELEMENT( 0, "/", p1)
$ IF p1 .EQS. "" THEN $ GOTO L1$
$ read_only := TRUE
$ IF qual .EQS. F$EXTRACT(0,F$LENGTH(qual),"READONLY") THEN $ GOTO SKIP_EXTRACTING
$ TELL "%TLBEDIT-F-BADQUAL, unknown qualifier used on library specification"
$ EXIT	F$VERIFY(verify).OR.1
$NO_LIBRARY:
$ TELL "%TLBEDIT-F-NOLIBFILE, no such file found"
$ EXIT	F$VERIFY(verify).OR.1
$SKIP_EXTRACTING:
$ p1 = F$PARSE( p1, "SYS$DISK:[].TLB;0")	!Get text library spec
$ IF F$SEARCH(p1) .EQS. "" THEN $ GOTO NO_LIBRARY
$ message_settings = F$ENVIRONMENT( "MESSAGE")
$ SET MESSAGE /NOFACILITY /IDENTIFICATION /NOSEVERITY /TEXT
$!
$! Main loop to input and decode the commands and dispatch to the processing
$! routines.
$!
$ commands = "/COMPRESS/COPY/CREATE/DELETE/DIRECTORY/EDIT/EXIT/LIST"
$ commands = commands + "/RENAME/TYPE/VIEW/EVIEW/MEDIT/XTRACT/HELP/"
$ len_commands = F$LENGTH(commands)
$MAIN_LOOP:
$ ON ERROR THEN $ GOTO FUNCTION_EXIT
$ ON CONTROL_Y THEN $ GOTO FUNCTION_EXIT
$ INQUIRE/NOPUNCTUATION  cline  "TED> "
$ cline = F$EDIT( cline, "COMPRESS,UPCASE,UNCOMMENT,TRIM")
$ IF cline .EQS. "?" THEN $ GOTO DISPLAY_FUNCTION_MENU
$ command = F$ELEMENT( 0, " ", cline)
$ IF F$LENGTH(command) .LT. 2 THEN $ GOTO CERROR_LEN
$ IF command .EQS. "CO" THEN $ GOTO CERROR_LEN
$ m = F$LOCATE( "/" + command, commands)
$ IF m .EQ. len_commands THEN $ GOTO CERROR_UNK
$ command = F$ELEMENT( 0, "/", F$EXTRACT(m, len_commands, commands) - "/")
$ arg1 = F$ELEMENT( 1, " ", cline)
$ IF arg1 .EQS. " " THEN arg1 = ""
$ arg2 = F$ELEMENT( 2, " ", cline)
$ IF arg2 .EQS. " " THEN arg2 = ""
$DISPATCH:
$ ON ERROR THEN $ GOTO MAIN_LOOP
$ ON CONTROL_Y THEN $ GOTO MAIN_LOOP
$ GOTO FUNCTION_'command'
$CERROR_LEN:
$ TELL "%TLBEDIT-E-TOOSHORT, command verb too short"
$ GOTO MAIN_LOOP
$CERROR_UNK:
$ TELL "%TLBEDIT-E-UNKCMD, unknown command verb"
$ GOTO MAIN_LOOP
$DISPLAY_FUNCTION_MENU:
$ TYPE SYS$INPUT:

 Current TLBEDIT commands are:

	COMPRESS	COPY	CREATE	DELETE	DIRECTORY	EDIT
	EVIEW	EXIT	HELP	LIST	MEDIT	RENAME	TYPE	VIEW
	XTRACT

$ GOTO MAIN_LOOP
$!
$! Here we process the various TED commands...
$!
$FUNCTION_COMPRESS:			!COMPRESS
$	LIBRARY/TEXT/COMPRESS	'p1'
$	p1x = p1 - F$PARSE( p1,,, "VERSION", "SYNTAX_ONLY")
$	PURGE  'p1x'
$	SET FILE/TRUNCATE	'p1'
$ GOTO MAIN_LOOP
$FUNCTION_COPY:				!COPY	old-module	new-module
$	IF arg1 .EQS. "" THEN $ INQUIRE  arg1  "Old module"
$	IF arg2 .EQS. "" THEN $ INQUIRE  arg2  "New module"
$	IF (arg1 .EQS. "") .OR. (arg2 .EQS. "") THEN $ GOTO FUNCTION_COPY
$	LIBRARY/TEXT/EXTRACT='arg1'/OUTPUT=COPY.TMP	'p1'
$	LIBRARY/LOG/TEXT/INSERT		'p1'	COPY.TMP/MODULE='arg2'
$	DELETE	COPY.TMP;*
$ GOTO MAIN_LOOP
$FUNCTION_CREATE:			!CREATE	new-module
$	IF arg1 .EQS. "" THEN $ INQUIRE  arg1  "New module"
$	IF arg1 .EQS. "" THEN $ GOTO FUNCTION_CREATE
$	DEFINE/USER_MODE  SYS$INPUT	SYS$COMMAND:
$	EE  CREATE.TMP
$	LIBRARY/LOG/TEXT/INSERT		'p1'	CREATE.TMP/MODULE='arg1'
$	DELETE	CREATE.TMP;*
$ GOTO MAIN_LOOP
$FUNCTION_DELETE:			!DELETE	module
$	IF arg1 .EQS. "" THEN $ INQUIRE  arg1  "Module"
$	IF arg1 .EQS. "" THEN $ GOTO FUNCTION_DELETE
$	LIBRARY/LOG/TEXT/DELETE='arg1'	'p1'
$ GOTO MAIN_LOOP
$FUNCTION_DIRECTORY:			!DIRECTORY
$	LIBRARY/TEXT/LIST/FULL	'p1'
$ GOTO MAIN_LOOP
$FUNCTION_EDIT:				!EDIT	module
$	IF arg1 .EQS. "" THEN $ INQUIRE  arg1  "Module"
$	IF arg1 .EQS. "" THEN $ GOTO FUNCTION_EDIT
$	LIBRARY/TEXT/EXTRACT='arg1'/OUTPUT=EDIT.TMP	'p1'
$	DEFINE/USER_MODE  SYS$INPUT	SYS$COMMAND:
$	EE  EDIT.TMP
$	LIBRARY/LOG/TEXT/REPLACE	'p1'	EDIT.TMP/MODULE='arg1'
$	DELETE	EDIT.TMP;*
$ GOTO MAIN_LOOP
$FUNCTION_HELP:				!HELP
$	DEFINE /USER_MODE	SYS$INPUT	SYS$COMMAND:
$	HELP /LIBRARY=FERMIHELP	TLBEDIT
$ GOTO MAIN_LOOP
$FUNCTION_LIST:				!LIST
$	LIBRARY/TEXT/LIST	'p1'
$ GOTO MAIN_LOOP
$FUNCTION_MEDIT:			!MEDIT
$	LIBRARY/TEXT/LIST=MODULES.LIS	'p1'
$	skipheader = 1
$	OPEN /READ	MDIRE	MODULES.LIS
$	CREATE /FDL=SYS$INPUT	MASSEDIT.TMP
		RECORD
			CARRIAGE_CONTROL	CARRIAGE_RETURN
			FORMAT			VARIABLE
$	OPEN /APPEND	MEX	MASSEDIT.TMP
$	MEDIT_XLOOP:
$		READ /END_OF_INFORMATION=MEDIT_XDONE	MDIRE	line
$		IF line .EQS. "" THEN $ GOTO MEDIT_XSKPX
$		IF skipheader THEN $ GOTO MEDIT_XLOOP
$		WRITE	MEX	"\module=",line
$		LIBRARY/TEXT/EXTRACT='line'/OUTPUT=M1.TMP	'p1'
$		APPEND	M1.TMP	MEX:
$		WRITE	MEX	"\eom"
$	GOTO MEDIT_XLOOP
$	MEDIT_XSKPX:			!End of listing header
$		skipheader = 0		!Now just a list of modules
$	GOTO MEDIT_XLOOP
$	MEDIT_XDONE:
$	CLOSE	MDIRE
$	DELETE	MODULES.LIS;*
$	CLOSE	MEX
$	DELETE	M1.TMP;*
$	DEFINE/USER_MODE  SYS$INPUT	SYS$COMMAND:
$	EE  MASSEDIT.TMP
$	OPEN /READ	MEX	MASSEDIT.TMP
$	MEDIT_RLOOP:
$		READ /END_OF_INFORMATION=MEDIT_RDONE	MEX	line
$		IF line .EQS. "\eom" THEN $ GOTO MEDIT_RLOOP
$		IF F$ELEMENT( 0, "=", line) .NES. "\module" THEN $ GOTO MED_ERR1
$		arg1 = F$ELEMENT( 1, "=", line)
$		CREATE /FDL=SYS$INPUT	M1.TMP
			RECORD
				CARRIAGE_CONTROL	CARRIAGE_RETURN
				FORMAT			VARIABLE
$		OPEN /APPEND	MDC	M1.TMP
$		MEDIT_MLOOP:
$			READ	MEX	line
$			IF line .EQS. "\eom" THEN $ GOTO MEDIT_MDONE
$			WRITE	MDC	line
$		GOTO MEDIT_MLOOP
$		MEDIT_MDONE:
$		CLOSE	MDC
$		LIBRARY/LOG/TEXT/REPLACE	'p1'	M1.TMP/MODULE='arg1'
$	GOTO MEDIT_RLOOP
$	MEDIT_RDONE:
$	CLOSE	MEX
$	DELETE	MASSEDIT.TMP;*
$	DELETE	M1.TMP;*
$ GOTO MAIN_LOOP
$MED_ERR1:
$	CLOSE	MEX
$	DELETE	MASSEDIT.TMP;*
$	DELETE	M1.TMP;*
$	WRITE SYS$OUTPUT "%TLBEDIT-E-MASEDFFE, error in output file format"
$ GOTO MAIN_LOOP
$FUNCTION_RENAME:			!RENAME	old-module	new-module
$	IF arg1 .EQS. "" THEN $ INQUIRE  arg1  "Module"
$	IF arg2 .EQS. "" THEN $ INQUIRE  arg2  "New name"
$	IF (arg1 .EQS. "") .OR. (arg2 .EQS. "") THEN $ GOTO FUNCTION_RENAME
$	LIBRARY/TEXT/EXTRACT='arg1'/OUTPUT=RENAME.TMP	'p1'
$	LIBRARY/LOG/TEXT/INSERT		'p1'	RENAME.TMP/MODULE='arg2'
$	DELETE	RENAME.TMP;*
$	LIBRARY/LOG/TEXT/DELETE='arg1'	'p1'
$ GOTO MAIN_LOOP
$FUNCTION_TYPE:				!TYPE	module
$	IF arg1 .EQS. "" THEN $ INQUIRE  arg1  "Module"
$	IF arg1 .EQS. "" THEN $ GOTO FUNCTION_TYPE
$	LIBRARY/TEXT/EXTRACT='arg1'/OUTPUT=SYS$OUTPUT	'p1'
$ GOTO MAIN_LOOP
$FUNCTION_VIEW:				!VIEW	module
$	IF arg1 .EQS. "" THEN $ INQUIRE  arg1  "Module"
$	IF arg1 .EQS. "" THEN $ GOTO FUNCTION_VIEW
$	LIBRARY/TEXT/EXTRACT='arg1'/OUTPUT=VIEW.TMP	'p1'
$	DEFINE/USER_MODE  SYS$INPUT	SYS$COMMAND:
$	VT  VIEW.TMP
$	DELETE	VIEW.TMP;*
$ GOTO MAIN_LOOP
$FUNCTION_EVIEW:			!EVIEW	module
$	IF arg1 .EQS. "" THEN $ INQUIRE  arg1  "Module"
$	IF arg1 .EQS. "" THEN $ GOTO FUNCTION_EVIEW
$	LIBRARY/TEXT/EXTRACT='arg1'/OUTPUT=EVIEW.TMP	'p1'
$	DEFINE/USER_MODE  SYS$INPUT	SYS$COMMAND:
$	EE /READ_ONLY  EVIEW.TMP
$	DELETE	EVIEW.TMP;*
$ GOTO MAIN_LOOP
$FUNCTION_XTRACT:			!XTRACT
$	IF arg1 .EQS. "" THEN arg1 = "TXT"
$	arg1 = arg1 - "."
$	LIBRARY/TEXT/LIST=MODULES.LIS	'p1'
$	skipheader = 1
$	OPEN /READ	XDIRE	MODULES.LIS
$	XTRACT_XLOOP:
$		READ /END_OF_INFORMATION=XTRACT_XDONE	XDIRE	line
$		IF line .EQS. "" THEN $ GOTO XTRACT_XSKPX
$		IF skipheader THEN $ GOTO XTRACT_XLOOP
$		LIBRARY/TEXT/LOG/EXTRACT='line'/OUTPUT='line'.'arg1'	'p1'
$	GOTO XTRACT_XLOOP
$	XTRACT_XSKPX:			!End of listing header
$		skipheader = 0		!Now just a list of modules
$	GOTO XTRACT_XLOOP
$	XTRACT_XDONE:
$	CLOSE	XDIRE
$	PURGE	*.'arg1'
$	DELETE	MODULES.LIS;*
$ GOTO MAIN_LOOP
$!
$FUNCTION_EXIT:
$ SET NOON
$ SET MESSAGE /NOFACILITY /NOIDENTIFICATION /NOSEVERITY /NOTEXT
$ DELETE  *.TMP;*
$ SET MESSAGE'message_settings'
$ EXIT	F$VERIFY(verify).OR.1
$!=============================================================================
$!+ TLBEDIT
$! This procedure provides an interactive interface to manipulate and edit
$! modules of a text library.  Format:
$!
$!	@FERMI$UTIL:TLBEDIT  text-library[/READONLY]
$!
$! If the /READONLY qualifier is used, modules may be examined but no
$! replacement operations or new module inserts will be done to the library.
$! By default the library is assumed to be in the current directory with
$! a file type of .TLB.
$!
$! The procedure prompts for input with "TED> ", the subtopics describe the
$! commands the procedure recognizes.
$!2 COMPRESS
$! Compress the library, creating a new version and purging the old:
$!
$!	TED> COMpress
$!
$!2 COPY
$! Create a new module by copying the contents of an existing module:
$!
$!	TED> COpy  old-module  new-module
$!
$!2 CREATE
$! Create a new module:
$!
$!	TED> CReate  new-module
$!
$! This command will enter the editor (in screen module) to enter the text
$! of the module.  EDIT/EDT will be used unless the symbol EDT is defined.
$! If the EDTX symbol is defined; it is used preferentially.
$!2 DELETE
$! Delete a module:
$!
$!	TED> DElete  module
$!
$!2 DIRECTORY
$! Provide a "directory" of the modules in the text library:
$!
$!	TED> DIrectory
$!
$!2 EDIT
$! Edit an existing module:
$!
$!	TED> EDit  module
$!
$! The module will be extracted from the library to a temporary edit
$! file and replaced after the exit is done.
$!
$! EDIT/EDT will be used unless the symbol EDT is defined.  
$! If the EDTX symbol is defined; it is used preferentially.
$!2 EVIEW
$! Examine the contents of a module using the editor in read-only
$! mode:
$!
$!	TED> EView  module
$!
$! EDIT/EDT will be used unless the symbol EDT is defined.  
$! If the EDTX symbol is defined; it is used preferentially.
$!2 EXIT
$! Exit the procedure:
$!
$!	TED> EXit
$!
$!2 HELP
$! List this information from the FERMIHELP library in SYS$HELP:.
$!
$!2 LIST
$! Provide a "directory" of the modules in the text library:
$!
$!	TED> LIst
$!
$!2 MEdit
$! Mass edit of many modules at once (for instance to perform one or
$! more global search and replace operations):
$!
$!	TED> MEdit
$!
$! All the modules are extracted and formed into a single file in which the
$! contents of each module is preceeded by a "\module" identifier line and
$! followed by a "\eom" terminator line:
$!
$!	\module=<name>
$!	<contents>
$!	...
$!	\eom
$!	...
$!
$! where <name> is the module name.  During the editing process if a module's
$! contents and identifer ("\module=") line are deleted, then the module in
$! the library will not be changed, otherwise all those modules with
$! identifier lines in the resulting file are replaced.
$!2 RENAME
$! Rename a module:
$!
$!	TED> REname  old-module  new-module
$!
$!2 TYPE
$! Display the contents of module:
$!
$!	TED> TYpe  module
$!
$!2 VIEW
$! Examine the contents of a module using the T display program:
$!
$!	TED> VIew  module
$!
$!2 XTRACT
$! Extract all the modules to separate files:
$!
$!	TED> XTract  [type]
$!
$! where the argument specifies the file type of the output files for
$! the extracted modules.  The default is ".TXT"
$!-
$! Modifications:
$!  01-Jun-85	FJN	Created to assist in construction LA100_CONTROLS
$!  03-Nov-85	FJN	Added "?" for quick help, added EVIEW command
$!  04-Dec-85	FJN	Started adding MassEdit command.
$!  21-Dec-85	FJN	Added XTract command.
$!  21-Jan-86	FJN	Added HELP command; TLBEDIT help into FERMIHELP
$!  11-Jul-86	FJN	If EDT or EDTX symbols defined, use then to invoke the
$!			editor rather than EDT.
