/*+ $CINDEF
 Connect to interrupt definitions for QIO parameters
*/
/* Extracted from V4.4 SYS$LIBRARY:LIB.REQ on  10-Jun-1986 */
#define CIN$M_EFN		0X1
#define CIN$M_USECAL		0X2
#define CIN$M_REPEAT		0X4
#define CIN$M_AST		0X8
#define CIN$M_INIDEV		0X10
#define CIN$M_START		0X20
#define CIN$M_ISR		0X40
#define CIN$M_CANCEL		0X80
#define CIN$M_EFNUM		0XFFFF0000

#define CIN$S_CINDEF		4
#define CIN$V_EFN		0	/* set event flag on interrupt. */
#define CIN$V_USECAL		1	/* use call interface. */
#define CIN$V_REPEAT		2	/* do repeated interrupt service. */
#define CIN$V_AST		3	/* queue ast on interrupt. */
#define CIN$V_INIDEV		4	/* device initialization to do. */
#define CIN$V_START		5	/* start i/o routine. */
#define CIN$V_ISR		6	/* isr to execute. */
#define CIN$V_CANCEL		7	/* cancel i/o routine. */
#define CIN$V_EFNUM		16
#define CIN$S_EFNUM		16	/* event flag number. */

struct cindef$r_flags {
    unsigned cin$v_efn : 1;		/* set event flag on interrupt. */
    unsigned cin$v_usecal : 1;		/* use call interface. */
    unsigned cin$v_repeat : 1;		/* do repeated interrupt service. */
    unsigned cin$v_ast : 1;		/* queue ast on interrupt. */
    unsigned cin$v_inidev : 1;		/* device initialization to do. */
    unsigned cin$v_start : 1;		/* start i/o routine. */
    unsigned cin$v_isr : 1;		/* isr to execute. */
    unsigned cin$v_cancel : 1;		/* cancel i/o routine. */
    unsigned : 8;
    unsigned cin$v_efnum : 16;		/* event flag number */
    };

struct cindef$r_entry_points {
    unsigned long cin$l_inidev;	/* offset to device init routine. */
    unsigned long cin$l_start;	/* offset to start device routine. */
    unsigned long cin$l_isr;	/* offset to interrupt service routine. */
    unsigned long cin$l_cancel;	/* offset to cancel i/o routine. */
    };

