$	VERIFY = F$VERIFY(0)
$	MODE = F$MODE()
$	IF MODE .NES. "INTERACTIVE" THEN MODE = "BATCH"
$	ON CONTROL_Y THEN GOTO DONE
$	ON WARNING THEN GOTO DONE
$	RUN ST_BIN:DATE
$!
$! Set up default values
$!
$	NAME = ""
$	SKIP_NAME = ""
$	GO_ON = " "
$	FILE_LIST = ""
$	P_LAST = 1
$	CMD_LINE = ""
$!
$!	Check the first argument for the presence of a "-".
$!
$	IF F$EXTRACT(0,1,P1) .NES. "-" THEN GOTO LOOP
$	    P_LAST = 2
$	    GO_ON = F$EXTRACT(1,1,P1)
$	    SKIP_NAME = F$EXTRACT(2,F$LENGTH(P1),P1)
$	    IF F$LOCATE(GO_ON,"AHNQSY") .NES. 6 THEN GOTO LOOP
$!
$!	Error:  the user specified a flag which is unknown.
$!
$	WRITE SYS$OUTPUT -
"%DOALL-W-BADFLAG, ''P1' is an unknown or illegal flag and will be ignored"
$	GOTO LOOP
$!
$!	Check the input arguments for the presence of blanks or special 
$!	characters.  Form the command line from the input arguments.
$!
$LOOP:
$	P_INDEX = 8
$LOOP_TOP:
$	THIS_P = P'P_INDEX'
$	TEST_STR := 'THIS_P'
$	COMPARE = (THIS_P .EQS. TEST_STR .AND. -
	    F$LOCATE(" ",THIS_P) .EQ. F$LENGTH(THIS_P)) + (THIS_P .EQS. "")
$	IF COMPARE .EQ. 2 .AND. CMD_LINE .NES. "" THEN -
	    CMD_LINE = """"" " + CMD_LINE 
$	IF COMPARE .EQ. 1 THEN -
	    CMD_LINE = P'P_INDEX' + " " + CMD_LINE
$	IF COMPARE .EQ. 0 THEN -
	    CMD_LINE = """" + P'P_INDEX' + """ " + CMD_LINE
$	P_INDEX = P_INDEX - 1
$	IF P_INDEX .GE. P_LAST THEN GOTO LOOP_TOP
$!
$	NAME_P_INX = P_LAST + 1
$	NAME_P_LEN = F$LENGTH(P'NAME_P_INX')
$	NAME_P = P'NAME_P_INX'
$	NAME_LOC = F$LOCATE(NAME_P,CMD_LINE)
$	CMD_NAME = P'P_LAST'
$	CMD_REST = F$EXTRACT(NAME_LOC+NAME_P_LEN,F$LENGTH(CMD_LINE),CMD_LINE)
$!
$! Check for UNIX/TOOLS flag "<"
$!
$	UNIX_FLAG = ""
$	IF F$EXTRACT(0,1,NAME_P) .NES. "<" THEN GOTO NO_TOOLS
$	    UNIX_FLAG = "<"
$	    NAME_P = F$EXTRACT(1,NAME_P_LEN,NAME_P)
$	    NAME_P_LEN = F$LENGTH(NAME_P)
$NO_TOOLS:
$!
$! Check for indirect file flag "@"
$!
$	IF F$EXTRACT(0,1,NAME_P) .NES. "@" THEN GOTO NO_INDIRECT
$	    FILE_LIST = F$EXTRACT(1,NAME_P_LEN,NAME_P)
$	    OPEN/SHARE=READ/READ/ERROR=NO_IND_FILE NAMES 'FILE_LIST'
$	    GOTO DOALL_LOOP
$!
$NO_INDIRECT:
$	NAME_LIST = NAME_P
$!
$DOALL_LOOP:
$!
$! Prepare for loop over all file names
$!
$	ON WARNING THEN GOTO ERROR_'MODE'
$	ON CONTROL_Y THEN GO_ON = " "
$	IF (MODE .EQS. "BATCH") .AND. (GO_ON .EQS. " ") THEN GO_ON = "A"
$!
$NEW_NAME:
$!
$!  Process next file name
$!
$	IF FILE_LIST .EQS. "" THEN GOTO SEARCH_NAME
$	    READ/END=DONE NAMES NAME
$	    IF .NOT. $STATUS THEN GOTO BAD_IND_READ 
$	    GOTO PROMPT
$!
$SEARCH_NAME:
$	SET NOON
$	SET MESSAGE/NOF/NOI/NOS/NOT
$	NEXT_NAME = F$SEARCH(NAME_LIST)
$	IF .NOT. $STATUS THEN GOTO BAD_SEARCH_NAME
$	SET MESSAGE/F/I/S/T
$	IF NAME .EQS. NEXT_NAME THEN GOTO DONE
$	NAME = NEXT_NAME
$	ON WARNING THEN GOTO ERROR_'MODE'
$	ON CONTROL_Y THEN GO_ON = " "
$!
$PROMPT:
$	IF NAME .EQS. "" THEN GOTO DONE
$	IF GO_ON .NES. "S" THEN GOTO PROMPT_1
$	    FILE_ENTRY = F$PARSE(F$EXTRACT(0,F$LOCATE(" ",NAME),NAME),,,"NAME")
$	    IF FILE_ENTRY .EQS. "" THEN FILE_ENTRY = NAME
$	    IF FILE_ENTRY .LTS. SKIP_NAME THEN GOTO NEW_NAME
$!
$!  Ask user if this file is to be processed
$!  (possible responses include "ALL", "YES", "SKIP", "NO", "HELP", and "QUIT")
$!
$PROMPT_1:
$	WRITE SYS$OUTPUT "$ ",CMD_NAME," ",UNIX_FLAG,NAME," ",CMD_REST
$	IF (MODE .EQS. "BATCH") .OR. (GO_ON .EQS. "A") THEN GOTO PROCESS
$	    INQUIRE/NOPUNCTUATION GO_ON "Process this file? "
$	    GO_ON := 'F$EXTRACT(0,1,GO_ON)'
$	    IF GO_ON .EQS. "A" THEN GOTO PROCESS
$	    IF GO_ON .EQS. "Y" THEN GOTO PROCESS
$	    IF GO_ON .EQS. "N" THEN GOTO NEW_NAME
$	    IF GO_ON .EQS. "S" THEN GOTO SKIP_TO_NAME
$	    IF GO_ON .EQS. "Q" THEN GOTO DONE
$	    IF GO_ON .EQS. "H" THEN GOTO HELP
$!
$	    WRITE SYS$ERROR  -
		"%DOALL-E-INVRESPONSE, ""''GO_ON'"" is not a valid response"
$	    WRITE SYS$ERROR " Enter ""H"" FOR HELP"
$	    GOTO PROMPT_1
$!
$SKIP_TO_NAME:
$	INQUIRE/NOPUNCTUATION SKIP_NAME "Skip to: "
$	GOTO NEW_NAME
$!
$HELP:
$	COPY SYS$INPUT SYS$OUTPUT 

Usage:  DOALL {-AHNQSY} command {<}{@}spec {options} ...

(If -S flag is given, then DOALL also expects a file name, e. g. "-Sfilename")

Prompt responses:
	Y - Yes:   Perform the command
	N - No:    Do not perform the command
	Q - Quit:  Stop processing and exit
	A - All:   Process remaining commands without prompting
	S - Skip:  Skip to a file name which equals or follows a string
		   (string is prompted for)
	H - Help:  Print this help

$	GOTO PROMPT_1
$!
$PROCESS:
$!
$!  Go ahead and apply the command to the file.
$!
$	SET NOON
$	ASSIGN/USER_MODE SYS$OUTPUT: SYS$INPUT:
$	'CMD_NAME' 'UNIX_FLAG''NAME' 'CMD_REST'
$	IF (MODE .EQS. "BATCH") .AND. ($SEVERITY .EQ. 4) THEN GOTO ERROR_BATCH
$	IF (MODE .EQS. "BATCH") .OR. $SEVERITY THEN GOTO NEW_NAME
$	GOTO ERROR_'MODE'
$!
$ERROR_INTERACTIVE:
$!
$!  Error detected.
$!  Reset go-on flag if in interactive mode.
$!
$	IF MODE .NES. "INTERACTIVE" THEN GOTO ERR_BATCH
$	    WRITE SYS$OUTPUT ""
$	    GO_ON = " "
$	    ON WARNING THEN GOTO ERROR_'MODE'
$	    GOTO NEW_NAME
$ERROR_BATCH:
$!
$!  Error detected.
$!  Print list of remaining file names if in batch mode
$!
$	ON WARNING THEN CLOSE NAMES/ERROR=NOTOPEN
$	SET NOVERIFY
$	WRITE SYS$OUTPUT -
	    "%DOALL-E-FILNOTPROC, The following files were not processed:"
$!
$GET_ERRNAME:
$	IF FILE_LIST .EQS. "" THEN GOTO NO_READ
$	    READ/END=DONE NAMES NAME
$	    IF .NOT. $STATUS THEN GOTO BAD_IND_READ 
$	    GOTO WRITE_ERRNAME
$!
$NO_READ:
$	NAME = F$SEARCH(NAME_LIST)
$	IF NAME .EQS. "" THEN GOTO DONE
$!
$WRITE_ERRNAME:
$	WRITE SYS$OUTPUT NAME
$	GOTO GET_ERRNAME
$!
$BAD_SEARCH_NAME:
$	ERROR_MSG = F$MESSAGE($STATUS)
$	SET MESSAGE/F/I/S/T
$	WRITE SYS$ERROR ERROR_MSG
$	WRITE SYS$ERROR -
		"%DOALL-F-BADLIST, the file list ''NAME_LIST' is illegal."
$	GOTO DONE
$!
$NO_IND_FILE:
$	ERROR_MSG = F$MESSAGE($STATUS)
$	WRITE SYS$ERROR ERROR_MSG
$	WRITE SYS$ERROR -
	    "%DOALL-F-NOINDFILE, the indirect file ''FILE_LIST' was not available"
$	GOTO DONE
$!
$BAD_IND_READ:
$	ERROR_MSG = F$MESSAGE($STATUS)
$	WRITE SYS$ERROR ERROR_MSG
$	WRITE SYS$ERROR -
	    "%DOALL-F-BADINDREAD, could not read the indirect file ''FILE_LIST'"
$	GOTO DONE
$!
$DONE:
$!
$!  Processing complete or error detected.
$!
$	SET MESSAGE/F/I/S/T
$	ON WARNING THEN GOTO NOTOPEN
$	CLOSE NAMES/ERROR=NOTOPEN
$NOTOPEN:
$	ON WARNING THEN EXIT $STATUS
$	RUN ST_BIN:DATE
$	IF MODE .EQS. "INTERACTIVE" THEN WRITE SYS$OUTPUT ""
$END:
$EXIT $STATUS
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$!								!
$!			DOALL.COM				!
$!								!
$!  This command file is designed to apply a single command to	!
$!  a group of files.  The command can be a DCL command, a	!
$!  defined shorthand command, a .COM file invocation, or a	!
$!  Software Tools command such as "FIND" (with the use of a 	!
$!  prefix).  The group of files can be specified by name, by 	!
$!  extension, or indirectly as a list of names in a file.  	!
$!  Each command will be echoed to the SYS$OUTPUT device.	!
$!  For full documentation, see [.DOC]DOALL.DOC			!
$!								!
$!  AUTHOR:	Jeffery Boes					!
$!  DATE:	March 1982	Initial release			!
$!		March 1984	Arguments preprocessed and	!
$!				command line flags		!
$!								!
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$!	 DEC/CMS REPLACEMENT HISTORY, Element DOALL.COM
$!	 *7    30-MAY-1985 13:44:02 BOES "Corrected command-echo to include UNIX_FLAG (optional ""<"")"
$!	 *6    10-DEC-1984 15:43:33 BOES "Fixed F$MODE for V4"
$!	 *5    15-MAY-1984 15:59:34 BOES ""
$!	 *4     3-APR-1984 09:45:21 BOES "Bug fixed by comparing return of F$SEARCH() with previous value"
$!	 *3    23-MAR-1984 15:42:14 BOES "Fixed bug"
$!	 *2    23-MAR-1984 13:54:45 BOES "New version with argument handling, -option"
$!	 *1    23-MAR-1984 13:53:33 BOES "Initial baseline version"
$!	 DEC/CMS REPLACEMENT HISTORY, Element DOALL.COM
